diff --git a/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/StrubeljTiselj/StrubeljTiselj.C b/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/StrubeljTiselj/StrubeljTiselj.C
new file mode 100644
index 000000000..aa1c8f26b
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/StrubeljTiselj/StrubeljTiselj.C
@@ -0,0 +1,94 @@
+/*---------------------------------------------------------------------------*\
+  ==  == ====== ====   ====    |
+                    \\     ||  | Unsupported Contributions for OpenFOAM
+  ======   //   ||  || ===//   |
+  ||  ||  //    ||  // || \\   | Copyright (C) 2018-2020 OpenFOAM Foundation
+  ==  == ====== ====   ==  ==  | and Helmholtz-Zentrum Dresden-Rossendorf
+-------------------------------------------------------------------------------
+License
+    This file is a derivative work of OpenFOAM.
+
+    OpenFOAM is free software: you can redistribute it and/or modify it
+    under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+    for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
+
+\*---------------------------------------------------------------------------*/
+
+#include "StrubeljTiselj.H"
+#include "phasePair.H"
+#include "addToRunTimeSelectionTable.H"
+#include "surfaceInterpolate.H"
+#include "fvcGrad.H"
+
+// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //
+
+namespace Foam
+{
+namespace dragModels
+{
+    defineTypeNameAndDebug(StrubeljTiselj, 0);
+    addToRunTimeSelectionTable(dragModel, StrubeljTiselj, dictionary);
+}
+}
+
+
+// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //
+
+Foam::dragModels::StrubeljTiselj::StrubeljTiselj
+(
+    const dictionary& dict,
+    const phasePair& pair,
+    const bool registerObject
+)
+:
+    dragModel(dict, pair, registerObject),
+    tau_("Tau", dimless, dict)
+{}
+
+
+// * * * * * * * * * * * * * * * * Destructor  * * * * * * * * * * * * * * * //
+
+Foam::dragModels::StrubeljTiselj::~StrubeljTiselj()
+{}
+
+
+// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //
+
+Foam::tmp<Foam::volScalarField> Foam::dragModels::StrubeljTiselj::Ki() const
+{
+    return
+        max(pair_.phase1(), pair_.phase1().residualAlpha())
+       *max(pair_.phase2(), pair_.phase2().residualAlpha())
+       *pair_.rho()*tau_/pair_.phase1().mesh().time().deltaT();
+}
+
+
+Foam::tmp<Foam::volScalarField> Foam::dragModels::StrubeljTiselj::K() const
+{
+    return Ki();
+}
+
+
+Foam::tmp<Foam::surfaceScalarField>Foam::dragModels::StrubeljTiselj::Kf() const
+{
+    return fvc::interpolate(Ki());
+}
+
+
+Foam::tmp<Foam::volScalarField> Foam::dragModels::StrubeljTiselj::CdRe() const
+{
+    notImplemented("dragModels::StrubeljTiselj::CdRe() const");
+
+    return tmp<volScalarField>(nullptr);
+}
+
+// ************************************************************************* //
diff --git a/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/StrubeljTiselj/StrubeljTiselj.H b/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/StrubeljTiselj/StrubeljTiselj.H
new file mode 100644
index 000000000..6c5374cb8
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/StrubeljTiselj/StrubeljTiselj.H
@@ -0,0 +1,121 @@
+/*---------------------------------------------------------------------------*\
+  ==  == ====== ====   ====    |
+                    \\     ||  | Unsupported Contributions for OpenFOAM
+  ======   //   ||  || ===//   |
+  ||  ||  //    ||  // || \\   | Copyright (C) 2018-2020 OpenFOAM Foundation
+  ==  == ====== ====   ==  ==  | and Helmholtz-Zentrum Dresden-Rossendorf
+-------------------------------------------------------------------------------
+License
+    This file is a derivative work of OpenFOAM.
+
+    OpenFOAM is free software: you can redistribute it and/or modify it
+    under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+    for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
+
+Class
+    Foam::dragModels::StrubeljTiselj
+
+Description
+    Numerical drag for handling of resolved interfaces in multi-fluid model
+
+    \verbatim
+        Strubelj, L. and Tiselj, I. 'Two-fluid model with interface sharpening'
+        International Journal for Numerical Methods in Engineering, Vol. 85,
+        pp. 575-590 (2011)
+    \endverbatim
+
+SourceFiles
+    StrubeljTiselj.C
+
+\*---------------------------------------------------------------------------*/
+
+#ifndef StrubeljTiselj_H
+#define StrubeljTiselj_H
+
+#include "dragModel.H"
+#include "phaseModel.H"
+
+// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
+
+namespace Foam
+{
+namespace dragModels
+{
+
+/*---------------------------------------------------------------------------*\
+                      Class StrubeljTiselj Declaration
+\*---------------------------------------------------------------------------*/
+
+class StrubeljTiselj
+:
+    public dragModel
+{
+    // Private Data
+
+        //- Ratio of physical time step to relaxation time
+        const dimensionedScalar tau_;
+
+
+public:
+
+    //- Runtime type information
+    TypeName("StrubeljTiselj");
+
+
+    // Constructors
+
+        //- Construct from a dictionary and a phase pair
+        StrubeljTiselj
+        (
+            const dictionary& dict,
+            const phasePair& pair,
+            const bool registerObject
+        );
+
+
+    //- Destructor
+    virtual ~StrubeljTiselj();
+
+
+    // Member Functions
+
+        //- Return the phase-intensive drag coefficient Ki
+        //  used in the momentum equations
+        //    ddt(alpha1*rho1*U1) + ... = ... alphad*K*(U1-U2)
+        //    ddt(alpha2*rho2*U2) + ... = ... alphad*K*(U2-U1)
+        virtual tmp<volScalarField> Ki() const;
+
+        //- Return the drag coefficient K as a scalar
+        //  used in the momentum equations
+        //    ddt(alpha1*rho1*U1) + ... = ... K*(U1-U2)
+        //    ddt(alpha2*rho2*U2) + ... = ... K*(U2-U1)
+        virtual tmp<volScalarField> K() const;
+
+        //- Return the drag coefficient Kf
+        //  used in the face-momentum equations
+        virtual tmp<surfaceScalarField> Kf() const;
+
+        //- Drag coefficient
+        virtual tmp<volScalarField> CdRe() const;
+};
+
+
+// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
+
+} // End namespace dragModels
+} // End namespace Foam
+
+// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
+
+#endif
+
+// ************************************************************************* //
diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/BlendedInterfacialModel/BlendedInterfacialModel.C b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/BlendedInterfacialModel/BlendedInterfacialModel.C
index abc7e3a52..299bb2e27 100644
--- a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/BlendedInterfacialModel/BlendedInterfacialModel.C
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/BlendedInterfacialModel/BlendedInterfacialModel.C
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     | Website:  https://openfoam.org
-    \\  /    A nd           | Copyright (C) 2014-2019 OpenFOAM Foundation
+    \\  /    A nd           | Copyright (C) 2014-2020 OpenFOAM Foundation
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
@@ -264,7 +264,7 @@ Foam::BlendedInterfacialModel<ModelType>::evaluate
 
     if (model2In1_.valid())
     {
-        addToXs(f2, (model1In2_().*method)(args ...));
+        addToXs(f2, (model2In1_().*method)(args ...));
     }
 
     if
diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/BlendedInterfacialModel/blendingMethods/definitePhases/definitePhases.C b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/BlendedInterfacialModel/blendingMethods/definitePhases/definitePhases.C
new file mode 100644
index 000000000..d3b7e5dc3
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/BlendedInterfacialModel/blendingMethods/definitePhases/definitePhases.C
@@ -0,0 +1,140 @@
+/*---------------------------------------------------------------------------*\
+  ==  == ====== ====   ====    |
+                    \\     ||  | Unsupported Contributions for OpenFOAM
+  ======   //   ||  || ===//   |
+  ||  ||  //    ||  // || \\   | Copyright (C) 2019-2020 OpenFOAM Foundation
+  ==  == ====== ====   ==  ==  | and Helmholtz-Zentrum Dresden-Rossendorf
+-------------------------------------------------------------------------------
+License
+    This file is a derivative work of OpenFOAM.
+
+    OpenFOAM is free software: you can redistribute it and/or modify it
+    under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+    for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
+
+\*---------------------------------------------------------------------------*/
+
+#include "definitePhases.H"
+#include "phaseSystem.H"
+#include "addToRunTimeSelectionTable.H"
+
+// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //
+
+namespace Foam
+{
+namespace blendingMethods
+{
+    defineTypeName(definitePhases);
+
+    addToRunTimeSelectionTable
+    (
+        blendingMethod,
+        definitePhases,
+        dictionary
+    );
+}
+}
+
+
+// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //
+
+Foam::blendingMethods::definitePhases::definitePhases
+(
+    const dictionary& dict,
+    const wordList& phaseNames
+)
+:
+    blendingMethod(dict)
+{}
+
+
+// * * * * * * * * * * * * * * * * Destructor  * * * * * * * * * * * * * * * //
+
+Foam::blendingMethods::definitePhases::~definitePhases()
+{}
+
+
+// * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * * //
+
+Foam::tmp<Foam::volScalarField> Foam::blendingMethods::definitePhases::f1
+(
+    const phaseModel& phase1,
+    const phaseModel& phase2
+) const
+{
+    if(phase1.fluid().continuousPhases().empty())
+    {
+        FatalErrorInFunction
+            << "The definitePhases blending requires at least one continuous "
+            << "phase, specified by keyword 'continuous' in phaseProperties."
+            << exit(FatalError);
+    }
+
+    const word phases12(IOobject::groupName(phase1.name(), phase2.name()));
+
+    tmp<volScalarField> f1
+    (
+        volScalarField::New
+        (
+            IOobject::groupName("f1."+typeName, phases12),
+            (!(phase1.continuous()))
+           *phase2
+           /max(phase2.fluid().sumAlphaContinuous(), phase2.residualAlpha())
+        )
+    );
+
+    if (debug && phase1.mesh().time().outputTime())
+    {
+        f1().write();
+    }
+
+    return f1;
+}
+
+
+Foam::tmp<Foam::volScalarField> Foam::blendingMethods::definitePhases::f2
+(
+    const phaseModel& phase1,
+    const phaseModel& phase2
+) const
+{
+    if(phase1.fluid().continuousPhases().empty())
+    {
+        FatalErrorInFunction
+        << "The definitePhases blending requires at least one continuous"
+        << "phase, specified by keyword 'continuous' in phaseProperties."
+            << exit(FatalError);
+    }
+
+    const word phases12(IOobject::groupName(phase1.name(), phase2.name()));
+
+    tmp<volScalarField> f2
+    (
+        volScalarField::New
+        (
+            IOobject::groupName("f2."+typeName, phases12),
+            (!(phase2.continuous()))
+           *phase1
+           /max(phase1.fluid().sumAlphaContinuous(), phase1.residualAlpha())
+        )
+    );
+
+    if (debug && phase1.mesh().time().outputTime())
+    {
+        f2().write();
+    }
+
+    return f2;
+}
+
+
+// ************************************************************************* //
diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/BlendedInterfacialModel/blendingMethods/definitePhases/definitePhases.H b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/BlendedInterfacialModel/blendingMethods/definitePhases/definitePhases.H
new file mode 100644
index 000000000..681c90c63
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/BlendedInterfacialModel/blendingMethods/definitePhases/definitePhases.H
@@ -0,0 +1,152 @@
+/*---------------------------------------------------------------------------*\
+  ==  == ====== ====   ====    |
+                    \\     ||  | Unsupported Contributions for OpenFOAM
+  ======   //   ||  || ===//   |
+  ||  ||  //    ||  // || \\   | Copyright (C) 2019-2020 OpenFOAM Foundation
+  ==  == ====== ====   ==  ==  | and Helmholtz-Zentrum Dresden-Rossendorf
+-------------------------------------------------------------------------------
+License
+    This file is a derivative work of OpenFOAM.
+
+    OpenFOAM is free software: you can redistribute it and/or modify it
+    under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+    for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
+
+Class
+    Foam::blendingMethods::definitePhases
+
+Description
+    This blending method is intended to work similar to the 'none' method, but
+    for an arbitrary number of disperse and of continuous phases.
+
+    For every phase, the function 'isDisperse' indicates, whether this phase is
+    disperse (1) or not (0). This information is taken from the list called
+    continuousPhases, which has to be provided by the user.
+
+    For a pair of continuous phases, the blending coefficient for any kind of
+    unordered phase pair model (e.g. '(water and oil)') is always equal to 1,
+    whereas f1 and f2 are always zero for such a pair.
+
+    For a pair of a continuous and a disperse phase, the blending coefficient
+    (f1 or f2) corresponding to the ordered phase pair model '(disperse in
+    continuous)' is one, wherever this specific continuous phase is present and
+    no other continuous phase is. This blending coefficient becomes zero, where
+    this specific continuous phase is not present at al. In regions, where
+    multiple continuous phases are present, the blending coefficient is
+    proportional to the ratio of the volume fraction of this specific continuous
+    phase and the sum of volume fractions of all continuous phases at this
+    point.
+
+    Blending factor f1 is corresponding to an ordered phase pair model
+    (phase1 in phase2). f2 is defined vice versa, accordingly
+    \f[
+        f_1 = \mathit{isDisperse}(\mathrm{phase1})
+            \frac{\alpha_2}{\alpha_{\Sigma c}}
+    \f]
+    \f[
+        f_2 = \mathit{isDisperse}(\mathrm{phase2})
+            \frac{\alpha_1}{\alpha_{\Sigma c}}
+    \f]
+
+    with the sum volume fraction of all phases declared as continuous
+    \f[
+        \alpha_{\Sigma c} = \Sigma_{i\in c} \alpha_i
+    \f]
+
+    Note, that the blending factors could be stored during runtime by enabling
+    the debug switch 'blendingMethod'. Calls to functions f1() and f2() may be
+    enforced with a debug switch for a specific model type,
+    e.g. 'BlendedInterfacialModel<dragModel> '.
+
+Usage
+    \table
+        Name              | Description                     | Example
+        continuous phases | declare phases to be continuous | (water oil)
+                          | under all circumstances         |
+    \endtable
+
+    Example for a phase system with an arbitrary number of disperse air phases
+    and both continuous phases of water and oil
+
+SourceFiles
+    definitePhases.C
+
+\*---------------------------------------------------------------------------*/
+
+#ifndef definitePhases_H
+#define definitePhases_H
+
+#include "blendingMethod.H"
+
+// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
+
+namespace Foam
+{
+namespace blendingMethods
+{
+
+/*---------------------------------------------------------------------------*\
+                        Class definitePhases Declaration
+\*---------------------------------------------------------------------------*/
+
+class definitePhases
+:
+    public blendingMethod
+{
+public:
+
+    //- Runtime type information
+    TypeNameNoDebug("definitePhases");
+
+
+    // Constructors
+
+        //- Construct from a dictionary and two phases
+        definitePhases
+        (
+            const dictionary& dict,
+            const wordList& phaseNames
+        );
+
+
+    //- Destructor
+    ~definitePhases();
+
+
+    // Member Functions
+
+        //- Factor for primary phase
+        virtual tmp<volScalarField> f1
+        (
+            const phaseModel& phase1,
+            const phaseModel& phase2
+        ) const;
+
+        //- Factor for secondary phase
+        virtual tmp<volScalarField> f2
+        (
+            const phaseModel& phase1,
+            const phaseModel& phase2
+        ) const;
+};
+
+
+// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
+
+} // End namespace blendingMethods
+} // End namespace Foam
+
+// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
+
+#endif
+
+// ************************************************************************* //
diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/Make/files b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/Make/files
index 9e3385057..787240118 100644
--- a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/Make/files
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/Make/files
@@ -76,6 +76,7 @@ BlendedInterfacialModel/blendingMethods/blendingMethod/newBlendingMethod.C
 BlendedInterfacialModel/blendingMethods/noBlending/noBlending.C
 BlendedInterfacialModel/blendingMethods/linear/linear.C
 BlendedInterfacialModel/blendingMethods/hyperbolic/hyperbolic.C
+BlendedInterfacialModel/blendingMethods/definitePhases/definitePhases.C
 
 reactionThermo/hRefConstThermos.C
 
diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/PhaseSystems/MomentumTransferPhaseSystem/MomentumTransferPhaseSystem.C b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/PhaseSystems/MomentumTransferPhaseSystem/MomentumTransferPhaseSystem.C
index 9df985ec0..f637286e9 100644
--- a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/PhaseSystems/MomentumTransferPhaseSystem/MomentumTransferPhaseSystem.C
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/PhaseSystems/MomentumTransferPhaseSystem/MomentumTransferPhaseSystem.C
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     | Website:  https://openfoam.org
-    \\  /    A nd           | Copyright (C) 2015-2019 OpenFOAM Foundation
+    \\  /    A nd           | Copyright (C) 2015-2020 OpenFOAM Foundation
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
@@ -176,38 +176,185 @@ MomentumTransferPhaseSystem
     const fvMesh& mesh
 )
 :
-    BasePhaseSystem(mesh)
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+    BasePhaseSystem(mesh),
+    correctFixedFluxBCs_
+    (
+        mesh.solutionDict().subDict("PIMPLE").lookupOrDefault<Switch>
+        (
+            "correctFixedFluxBCs",
+            true
+        )
+    )
 {
     this->generatePairsAndSubModels
     (
         "drag",
-        dragModels_
+        dragModels_,
+        correctFixedFluxBCs_
     );
 
     this->generatePairsAndSubModels
     (
         "virtualMass",
-        virtualMassModels_
+        virtualMassModels_,
+        correctFixedFluxBCs_
     );
 
     this->generatePairsAndSubModels
     (
         "lift",
-        liftModels_
+        liftModels_,
+        correctFixedFluxBCs_
     );
 
     this->generatePairsAndSubModels
     (
         "wallLubrication",
-        wallLubricationModels_
+        wallLubricationModels_,
+        correctFixedFluxBCs_
     );
 
     this->generatePairsAndSubModels
     (
         "turbulentDispersion",
-        turbulentDispersionModels_
+        turbulentDispersionModels_,
+        correctFixedFluxBCs_
     );
 
+    forAllConstIter
+    (
+        liftModelTable,
+        liftModels_,
+        liftModelIter
+    )
+    {
+        const phasePair& pair(this->phasePairs_[liftModelIter.key()]);
+
+        Fls_.insert
+        (
+            pair,
+            new volVectorField
+            (
+                IOobject
+                (
+                    IOobject::groupName("Fl", pair.name()),
+                    this->mesh().time().timeName(),
+                    this->mesh()
+                ),
+                this->mesh(),
+                dimensionedVector(liftModel::dimF, Zero)
+            )
+        );
+
+        Flfs_.insert
+        (
+            pair,
+            new surfaceScalarField
+            (
+                IOobject
+                (
+                    IOobject::groupName("Flf", pair.name()),
+                    this->mesh().time().timeName(),
+                    this->mesh()
+                ),
+                this->mesh(),
+                dimensionedScalar(liftModel::dimF*dimArea, 0)
+            )
+        );
+    }
+
+    forAllConstIter
+    (
+        wallLubricationModelTable,
+        wallLubricationModels_,
+        wallLubricationModelIter
+    )
+    {
+        const phasePair& pair
+        (
+            this->phasePairs_[wallLubricationModelIter.key()]
+        );
+
+        Fws_.insert
+        (
+            pair,
+            new volVectorField
+            (
+                IOobject
+                (
+                    IOobject::groupName("Fw", pair.name()),
+                    this->mesh().time().timeName(),
+                    this->mesh()
+                ),
+                this->mesh(),
+                dimensionedVector(wallLubricationModel::dimF, Zero)
+            )
+        );
+
+        Fwfs_.insert
+        (
+            pair,
+            new surfaceScalarField
+            (
+                IOobject
+                (
+                    IOobject::groupName("Fwf", pair.name()),
+                    this->mesh().time().timeName(),
+                    this->mesh()
+                ),
+                this->mesh(),
+                dimensionedScalar(wallLubricationModel::dimF*dimArea, 0)
+            )
+        );
+    }
+
+    forAllConstIter
+    (
+        turbulentDispersionModelTable,
+        turbulentDispersionModels_,
+        turbulentDispersionModelIter
+    )
+    {
+        const phasePair& pair
+        (
+            this->phasePairs_[turbulentDispersionModelIter.key()]
+        );
+
+        Fts_.insert
+        (
+            pair,
+            new volVectorField
+            (
+                IOobject
+                (
+                    IOobject::groupName("Ft", pair.name()),
+                    this->mesh().time().timeName(),
+                    this->mesh()
+                ),
+                this->mesh(),
+                dimensionedVector(turbulentDispersionModel::dimF, Zero)
+            )
+        );
+
+        Ftfs_.insert
+        (
+            pair,
+            new surfaceScalarField
+            (
+                IOobject
+                (
+                    IOobject::groupName("Ftf", pair.name()),
+                    this->mesh().time().timeName(),
+                    this->mesh()
+                ),
+                this->mesh(),
+                dimensionedScalar(turbulentDispersionModel::dimF*dimArea, 0)
+            )
+        );
+    }
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
     forAllConstIter
     (
         dragModelTable,
@@ -399,6 +546,48 @@ Foam::MomentumTransferPhaseSystem<BasePhaseSystem>::momentumTransfer()
         }
     }
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+    // Update the lift forces
+    forAllConstIter
+    (
+        liftModelTable,
+        liftModels_,
+        liftModelIter
+    )
+    {
+        *Fls_[liftModelIter.key()] = liftModelIter()->F<vector>();
+        *Flfs_[liftModelIter.key()] = liftModelIter()->Ff();
+    }
+
+    // Update the wall lubrication forces
+    forAllConstIter
+    (
+        wallLubricationModelTable,
+        wallLubricationModels_,
+        wallLubricationModelIter
+    )
+    {
+        *Fws_[wallLubricationModelIter.key()] =
+            wallLubricationModelIter()->F<vector>();
+        *Fwfs_[wallLubricationModelIter.key()] =
+            wallLubricationModelIter()->Ff();
+    }
+
+    // Update the turbulent dispersion coefficients
+    forAllConstIter
+    (
+        turbulentDispersionModelTable,
+        turbulentDispersionModels_,
+        turbulentDispersionModelIter
+    )
+    {
+        *Fts_[turbulentDispersionModelIter.key()] =
+            turbulentDispersionModelIter()->F<vector>();
+        *Ftfs_[turbulentDispersionModelIter.key()] =
+            turbulentDispersionModelIter()->Ff();
+    }
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
     return eqnsPtr;
 }
 
